/*..........................................................................*/
/*                                                                          */
/*      L a s t W a v e   K e r n e l   2 . 0 . 2                           */
/*                                                                          */
/*      (C) 1998-2003 Copyright Emmanuel Bacry, All Right Reserved.         */
/*      Author Emmanuel Bacry                                               */
/*                                                                          */
/*..........................................................................*/



/****************************************************************************/
/*                                                                          */
/*  int_loop.c       This file contains the basic initializations required  */
/*                   by the interpreter langage, and its main loop          */
/*                                                                          */
/****************************************************************************/

#include "lastwave.h"
#include "xx_system.h" /* ANSI changed */




/*****************************/
/* The start and the end     */
/*****************************/

extern void CloseTerminal(void);
extern void InitProcs(void);
extern void InitTerminal(void);
extern void InitCPUBinaryMode(void) ;


static void Start(void)
 {
  InitCPUBinaryMode();
  
  InitTerminal();

  /* Needs to be here for the -b option ... don't understand why ???*/
  Flush();
  
  InitGraphics();


  InitToplevels();

}

void LWEnd(void) 
{
  CloseGraphics();  
  CloseAllToplevels();
  CloseTerminal();
}


/*********************/
/* The main function */
/*********************/


void LWInit(void)
{
  char flag;
  char startup[] = "source startup";
  char *s;
  
  XXStartup(NULL,NULL);
  
  flag = GraphicMode;   

  Start();
      
  Printf("***************************************************************************\n");
  Printf("****\n");
  Printf("****   L a s t W a v e   %s         ",SOFTVERSION);
  Printf("****\n");
  Printf("****   Copyright (C) 1998-2008 E. Bacry.\n");
  Printf("****\n");
  Printf("****   CMAP, Ecole Polytechnique, 91128 Cedex, Palaiseau, FRANCE.\n");
  Printf("****   (lastwave@cmap.polytechnique.fr )\n");
  Printf("****\n");
  Printf("****   LastWave comes with ABSOLUTELY NO WARRANTY.\n");
  Printf("****   It is a free software and you are welcome to redistribute it\n");
  Printf("****   under certain circumstances.\n");
  Printf("****   For details read the file COPYRIGHT.\n");
  Printf("****\n");
  Printf("***************************************************************************\n\n\n");

  /* Some initializations */
  InitProcs();

  /* Some initializations */
  if (setjmp(toplevelCur->environment) == 0) {
    InitResult();
    SetResultStr("");
    SetVariable("argv",GetResultValue());
    InitResult();
    UserInit();  
  }
  else {
    PrintfErr("** The above error occured while executing the 'UserInit' function\n"); 
  }

  for (s = startup; s[0] != '\0'; s++) {  
    PushBuffer(_StdinStream->buffer,*s);
  }
  
  PushBuffer(_StdinStream->buffer,NewlineKC);
  
  ProcessNextEvent(NULL);  
}








